{
  This file was automatically generated on 2012-10-01.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickMaster;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE = 1;
  BRICK_MASTER_FUNCTION_GET_STACK_CURRENT = 2;
  BRICK_MASTER_FUNCTION_SET_EXTENSION_TYPE = 3;
  BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE = 4;
  BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT = 5;
  BRICK_MASTER_FUNCTION_SET_CHIBI_ADDRESS = 6;
  BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS = 7;
  BRICK_MASTER_FUNCTION_SET_CHIBI_MASTER_ADDRESS = 8;
  BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS = 9;
  BRICK_MASTER_FUNCTION_SET_CHIBI_SLAVE_ADDRESS = 10;
  BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS = 11;
  BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH = 12;
  BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG = 13;
  BRICK_MASTER_FUNCTION_SET_CHIBI_FREQUENCY = 14;
  BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY = 15;
  BRICK_MASTER_FUNCTION_SET_CHIBI_CHANNEL = 16;
  BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL = 17;
  BRICK_MASTER_FUNCTION_IS_RS485_PRESENT = 18;
  BRICK_MASTER_FUNCTION_SET_RS485_ADDRESS = 19;
  BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS = 20;
  BRICK_MASTER_FUNCTION_SET_RS485_SLAVE_ADDRESS = 21;
  BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS = 22;
  BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG = 23;
  BRICK_MASTER_FUNCTION_SET_RS485_CONFIGURATION = 24;
  BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION = 25;
  BRICK_MASTER_FUNCTION_IS_WIFI_PRESENT = 26;
  BRICK_MASTER_FUNCTION_SET_WIFI_CONFIGURATION = 27;
  BRICK_MASTER_FUNCTION_GET_WIFI_CONFIGURATION = 28;
  BRICK_MASTER_FUNCTION_SET_WIFI_ENCRYPTION = 29;
  BRICK_MASTER_FUNCTION_GET_WIFI_ENCRYPTION = 30;
  BRICK_MASTER_FUNCTION_GET_WIFI_STATUS = 31;
  BRICK_MASTER_FUNCTION_REFRESH_WIFI_STATUS = 32;
  BRICK_MASTER_FUNCTION_SET_WIFI_CERTIFICATE = 33;
  BRICK_MASTER_FUNCTION_GET_WIFI_CERTIFICATE = 34;
  BRICK_MASTER_FUNCTION_SET_WIFI_POWER_MODE = 35;
  BRICK_MASTER_FUNCTION_GET_WIFI_POWER_MODE = 36;
  BRICK_MASTER_FUNCTION_GET_WIFI_BUFFER_INFO = 37;
  BRICK_MASTER_FUNCTION_SET_WIFI_REGULATORY_DOMAIN = 38;
  BRICK_MASTER_FUNCTION_GET_WIFI_REGULATORY_DOMAIN = 39;
  BRICK_MASTER_FUNCTION_RESET = 243;
  BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE = 242;

type
  TArray0To31OfUInt8 = array [0..31] of byte;
  TArray0To5OfUInt8 = array [0..31] of byte;
  TArray0To3OfUInt8 = array [0..31] of byte;

  /// <summary>
  ///  Device for controlling Stacks and four Bricklets
  /// </summary>
  TBrickMaster = class(TDevice)
  private
  protected
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid_: string);

    /// <summary>
    ///  Returns the stack voltage in mV. The stack voltage is the
    ///  voltage that is supplied via the stack, i.e. it is given by a 
    ///  Step-Down or Step-Up Power Supply.
    /// </summary>
    function GetStackVoltage: word; virtual;

    /// <summary>
    ///  Returns the stack current in mA. The stack current is the
    ///  current that is drawn via the stack, i.e. it is given by a
    ///  Step-Down or Step-Up Power Supply.
    /// </summary>
    function GetStackCurrent: word; virtual;

    /// <summary>
    ///  Writes the extension type to the EEPROM of a specified extension. 
    ///  The extension is either 0 or 1 (0 is the on the bottom, 1 is the on on top, 
    ///  if only one extension is present use 0).
    ///  
    ///  Possible extension types:
    ///  
    ///  <code>
    ///   "Type", "Description"
    ///  
    ///   "1",    "Chibi"
    ///   "2",    "RS485"
    ///   "3",    "WIFI"
    ///  </code>
    ///  
    ///  The extension type is already set when bought and it can be set with the 
    ///  Brick Viewer, it is unlikely that you need this function.
    ///  
    ///  The value will be saved in the EEPROM of the Chibi Extension, it does not
    ///  have to be set on every startup.
    /// </summary>
    procedure SetExtensionType(const extension: byte; const exttype: longword); virtual;

    /// <summary>
    ///  Returns the extension type for a given extension as set by 
    ///  <see cref="BrickMaster.TBrickMaster.SetExtensionType"/>.
    /// </summary>
    function GetExtensionType(const extension: byte): longword; virtual;

    /// <summary>
    ///  Returns *true* if a Chibi Extension is available to be used by the Master.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    function IsChibiPresent: boolean; virtual;

    /// <summary>
    ///  Sets the address (1-255) belonging to the Chibi Extension.
    ///  
    ///  It is possible to set the address with the Brick Viewer and it will be 
    ///  saved in the EEPROM of the Chibi Extension, it does not
    ///  have to be set on every startup.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    procedure SetChibiAddress(const address: byte); virtual;

    /// <summary>
    ///  Returns the address as set by <see cref="BrickMaster.TBrickMaster.SetChibiAddress"/>.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    function GetChibiAddress: byte; virtual;

    /// <summary>
    ///  Sets the address (1-255) of the Chibi Master. This address is used if the
    ///  Chibi Extension is used as slave (i.e. it does not have a USB connection).
    ///  
    ///  It is possible to set the address with the Brick Viewer and it will be 
    ///  saved in the EEPROM of the Chibi Extension, it does not
    ///  have to be set on every startup.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    procedure SetChibiMasterAddress(const address: byte); virtual;

    /// <summary>
    ///  Returns the address as set by <see cref="BrickMaster.TBrickMaster.SetChibiMasterAddress"/>.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    function GetChibiMasterAddress: byte; virtual;

    /// <summary>
    ///  Sets up to 254 slave addresses. Valid addresses are in range 1-255.
    ///  The address numeration (via num parameter) has to be used
    ///  ascending from 0. For example: If you use the Chibi Extension in Master mode
    ///  (i.e. the stack has an USB connection) and you want to talk to three other
    ///  Chibi stacks with the slave addresses 17, 23, and 42, you should call with "(0, 17),
    ///  (1, 23) and (2, 42)".
    ///  
    ///  It is possible to set the addresses with the Brick Viewer and it will be 
    ///  saved in the EEPROM of the Chibi Extension, they don't
    ///  have to be set on every startup.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    procedure SetChibiSlaveAddress(const num: byte; const address: byte); virtual;

    /// <summary>
    ///  Returns the slave address for a given num as set by 
    ///  <see cref="BrickMaster.TBrickMaster.SetChibiSlaveAddress"/>.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    function GetChibiSlaveAddress(const num: byte): byte; virtual;

    /// <summary>
    ///  Returns the signal strength in dBm. The signal strength updates every time a
    ///  packet is received.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    function GetChibiSignalStrength: byte; virtual;

    /// <summary>
    ///  Returns underrun, CRC error, no ACK and overflow error counts of the Chibi
    ///  communication. If these errors start rising, it is likely that either the
    ///  distance between two Chibi stacks is becoming too big or there are
    ///  interferences.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    procedure GetChibiErrorLog(out underrun: word; out crcError: word; out noAck: word; out overflow: word); virtual;

    /// <summary>
    ///  Sets the Chibi frequency range for the Chibi Extension. Possible values are:
    ///  
    ///  <code>
    ///   "Type", "Description"
    ///  
    ///   "0",    "OQPSK 868Mhz (Europe)"
    ///   "1",    "OQPSK 915Mhz (US)"
    ///   "2",    "OQPSK 780Mhz (China)"
    ///   "3",    "BPSK40 915Mhz"
    ///  </code>
    ///  
    ///  It is possible to set the frequency with the Brick Viewer and it will be 
    ///  saved in the EEPROM of the Chibi Extension, it does not
    ///  have to be set on every startup.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    procedure SetChibiFrequency(const frequency: byte); virtual;

    /// <summary>
    ///  Returns the frequency value as set by <see cref="BrickMaster.TBrickMaster.SetChibiFrequency"/>.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    function GetChibiFrequency: byte; virtual;

    /// <summary>
    ///  Sets the channel used by the Chibi Extension. Possible channels are
    ///  different for different frequencies:
    ///  
    ///  <code>
    ///   "Frequency",             "Possible Channels"
    ///  
    ///   "OQPSK 868Mhz (Europe)", "0"
    ///   "OQPSK 915Mhz (US)",     "1, 2, 3, 4, 5, 6, 7, 8, 9, 10"
    ///   "OQPSK 780Mhz (China)",  "0, 1, 2, 3"
    ///   "BPSK40 915Mhz",         "1, 2, 3, 4, 5, 6, 7, 8, 9, 10"
    ///  </code>
    ///  
    ///  It is possible to set the channel with the Brick Viewer and it will be 
    ///  saved in the EEPROM of the Chibi Extension, it does not
    ///  have to be set on every startup.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    procedure SetChibiChannel(const channel: byte); virtual;

    /// <summary>
    ///  Returns the channel as set by <see cref="BrickMaster.TBrickMaster.SetChibiChannel"/>.
    ///  
    ///  .. versionadded:: 1.1.0
    /// </summary>
    function GetChibiChannel: byte; virtual;

    /// <summary>
    ///  Returns *true* if a RS485 Extension is available to be used by the Master.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    function IsRS485Present: boolean; virtual;

    /// <summary>
    ///  Sets the address (1-255) belonging to the RS485 Extension.
    ///  
    ///  Set to 0 if the RS485 Extension should be the RS485 Master (i.e.
    ///  connected to a PC via USB).
    ///  
    ///  It is possible to set the address with the Brick Viewer and it will be 
    ///  saved in the EEPROM of the RS485 Extension, it does not
    ///  have to be set on every startup.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    procedure SetRS485Address(const address: byte); virtual;

    /// <summary>
    ///  Returns the address as set by <see cref="BrickMaster.TBrickMaster.SetRS485Address"/>.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    function GetRS485Address: byte; virtual;

    /// <summary>
    ///  Sets up to 255 slave addresses. Valid addresses are in range 1-255.
    ///  The address numeration (via num parameter) has to be used
    ///  ascending from 0. For example: If you use the RS485 Extension in Master mode
    ///  (i.e. the stack has an USB connection) and you want to talk to three other
    ///  RS485 stacks with the IDs 17, 23, and 42, you should call with "(0, 17),
    ///  (1, 23) and (2, 42)".
    ///  
    ///  It is possible to set the addresses with the Brick Viewer and it will be 
    ///  saved in the EEPROM of the RS485 Extension, they don't
    ///  have to be set on every startup.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    procedure SetRS485SlaveAddress(const num: byte; const address: byte); virtual;

    /// <summary>
    ///  Returns the slave address for a given num as set by 
    ///  <see cref="BrickMaster.TBrickMaster.SetRS485SlaveAddress"/>.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    function GetRS485SlaveAddress(const num: byte): byte; virtual;

    /// <summary>
    ///  Returns CRC error counts of the RS485 communication.
    ///  If this counter starts rising, it is likely that the distance
    ///  between the RS485 nodes is too big or there is some kind of
    ///  interference.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    function GetRS485ErrorLog: word; virtual;

    /// <summary>
    ///  Sets the configuration of the RS485 Extension. Speed is given in baud. The
    ///  Master Brick will try to match the given baud rate as exactly as possible.
    ///  The maximum recommended baud rate is 2000000 (2Mbit/s).
    ///  Possible values for parity are 'n' (none), 'e' (even) and 'o' (odd).
    ///  Possible values for stop bits are 1 and 2.
    ///  
    ///  If your RS485 is unstable (lost messages etc), the first thing you should
    ///  try is to decrease the speed. On very large bus (e.g. 1km), you probably
    ///  should use a value in the range of 100khz.
    ///  
    ///  The values are stored in the EEPROM and only applied on startup. That means
    ///  you have to restart the Master Brick after configuration.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    procedure SetRS485Configuration(const speed: longword; const parity: char; const stopbits: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickMaster.TBrickMaster.SetRS485Configuration"/>.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    procedure GetRS485Configuration(out speed: longword; out parity: char; out stopbits: byte); virtual;

    /// <summary>
    ///  Returns *true* if a WIFI Extension is available to be used by the Master.
    ///  
    ///  .. versionadded:: 1.2.0
    /// </summary>
    function IsWifiPresent: boolean; virtual;

    /// <summary>
    ///  Sets the configuration of the WIFI Extension. The ssid can have a max length
    ///  of 32 characters, the connection is either 0 for DHCP or 1 for static IP.
    ///  
    ///  If you set connection to 1, you have to supply ip, subnet mask and gateway
    ///  as an array of size 4 (first element of the array is the least significant
    ///  byte of the address). If connection is set to 0 ip, subnet mask and gateway
    ///  are ignored, you can set them to 0.
    ///  
    ///  The last parameter is the port that your program will connect to. The
    ///  default port, that is used by brickd, is 4223.
    ///  
    ///  The values are stored in the EEPROM and only applied on startup. That means
    ///  you have to restart the Master Brick after configuration.
    ///  
    ///  It is recommended to use the Brick Viewer to set the WIFI configuration.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure SetWifiConfiguration(const ssid: string; const connection: byte; const ip: TArray0To3OfUInt8; const subnetMask: TArray0To3OfUInt8; const gateway: TArray0To3OfUInt8; const port: word); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickMaster.TBrickMaster.SetWifiConfiguration"/>.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure GetWifiConfiguration(out ssid: string; out connection: byte; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out port: word); virtual;

    /// <summary>
    ///  Sets the encryption of the WIFI Extension. The first parameter is the
    ///  type of the encryption. Possible values are:
    ///  
    ///  <code>
    ///   "Value", "Description"
    ///  
    ///   "0", "WPA/WPA2"
    ///   "1", "WPA Enterprise (EAP-FAST, EAP-TLS, EAP-TTLS, PEAP)"
    ///   "2", "WEP"
    ///   "3", "Open Network"
    ///  </code>
    ///  
    ///  The key has a max length of 50 characters and is used if encryption
    ///  is set to 0 or 2 (WPA or WEP). Otherwise the value is ignored.
    ///  For WEP it is possible to set the key index (1-4). If you don't know your
    ///  key index, it is likely 1.
    ///  
    ///  If you choose WPA Enterprise as encryption, you have to set eap options and
    ///  the length of the certificates (for other encryption types these paramters
    ///  are ignored). The certificate length are given in byte and the certificates
    ///  themself can be set with  <see cref="BrickMaster.TBrickMaster.SetWifiCertificate"/>. Eap options consist of 
    ///  the outer authentication (bits 1-2), inner authentication (bit 3) and 
    ///  certificate type (bits 4-5):
    ///  
    ///  <code>
    ///   "Option", "Bits", "Description"
    ///  
    ///   "outer auth", "1-2", "0=EAP-FAST, 1=EAP-TLS, 2=EAP-TTLS, 3=EAP-PEAP"
    ///   "inner auth", "3", "0=EAP-MSCHAP, 1=EAP-GTC"
    ///   "cert type", "4-5", "0=CA Certificate, 1=Client Certificate, 2=Private Key"
    ///  </code>
    ///  
    ///  Example for EAP-TTLS + EAP-GTC + Private Key: option = 2 | (1 &lt;&lt; 2) | (2 &lt;&lt; 3).
    ///  
    ///  The values are stored in the EEPROM and only applied on startup. That means
    ///  you have to restart the Master Brick after configuration.
    ///  
    ///  It is recommended to use the Brick Viewer to set the WIFI encryption.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure SetWifiEncryption(const encryption: byte; const key: string; const keyIndex: byte; const eapOptions: byte; const caCertificateLength: word; const clientCertificateLength: word; const privateKeyLength: word); virtual;

    /// <summary>
    ///  Returns the encryption as set by <see cref="BrickMaster.TBrickMaster.SetWifiEncryption"/>.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure GetWifiEncryption(out encryption: byte; out key: string; out keyIndex: byte; out eapOptions: byte; out caCertificateLength: word; out clientCertificateLength: word; out privateKeyLength: word); virtual;

    /// <summary>
    ///  Returns the status of the WIFI Extension. The state is updated automatically,
    ///  all of the other parameters are updated on startup and every time
    ///  <see cref="BrickMaster.TBrickMaster.RefreshWifiStatus"/> is called.
    ///  
    ///  Possible states are:
    ///  
    ///  <code>
    ///   "State", "Description"
    ///  
    ///   "0", "Disassociated"
    ///   "1", "Associated"
    ///   "2", "Associating"
    ///   "3", "Error"
    ///   "255", "Not initialized yet"
    ///  </code>
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure GetWifiStatus(out macAddress: TArray0To5OfUInt8; out bssid: TArray0To5OfUInt8; out channel: byte; out rssi: smallint; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out rxCount: longword; out txCount: longword; out state: byte); virtual;

    /// <summary>
    ///  Refreshes the WIFI status (see <see cref="BrickMaster.TBrickMaster.GetWifiStatus"/>). To read the status
    ///  of the WIFI module, the Master Brick has to change from data mode to
    ///  command mode and back. This transaction and the readout itself is
    ///  unfortunately time consuming. This means, that it might take some ms
    ///  until the stack with attached WIFI Extensions reacts again after this
    ///  function is called.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure RefreshWifiStatus; virtual;

    /// <summary>
    ///  This function is used to set the certificate as well as password and username
    ///  for WPA Enterprise. To set the username use index 0xFFFF,
    ///  to set the password use index 0xFFFE. The max length of username and 
    ///  password is 32.
    ///  
    ///  The certificate is written in chunks of size 32 and the index is used as
    ///  the index of the chunk. The data length should nearly always be 32. Only
    ///  the last chunk can have a length that is not equal to 32.
    ///  
    ///  The starting index of the CA Certificate is 0, of the Client Certificate
    ///  10000 and for the Private Key 20000. Maximum sizes are 1312, 1312 and
    ///  4320 byte respectively.
    ///  
    ///  The values are stored in the EEPROM and only applied on startup. That means
    ///  you have to restart the Master Brick after uploading the certificate.
    ///  
    ///  It is recommended to use the Brick Viewer to set the certificate, username
    ///  and password.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure SetWifiCertificate(const index: word; const data: TArray0To31OfUInt8; const dataLength: byte); virtual;

    /// <summary>
    ///  Returns the certificate for a given index as set by <see cref="BrickMaster.TBrickMaster.SetWifiCertificate"/>.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure GetWifiCertificate(const index: word; out data: TArray0To31OfUInt8; out dataLength: byte); virtual;

    /// <summary>
    ///  Sets the power mode of the WIFI Extension. Possible modes are:
    ///  
    ///  <code>
    ///   "Mode", "Description"
    ///  
    ///   "0", "Full Speed (high power consumption, high throughput)"
    ///   "1", "Low Power (low power consumption, low throughput)"
    ///  </code>
    ///  
    ///  The default value is 0 (Full Speed).
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    procedure SetWifiPowerMode(const mode: byte); virtual;

    /// <summary>
    ///  Returns the power mode as set by <see cref="BrickMaster.TBrickMaster.SetWifiPowerMode"/>.
    ///  
    ///  .. versionadded:: 1.3.0
    /// </summary>
    function GetWifiPowerMode: byte; virtual;

    /// <summary>
    ///  Returns informations about the WIFI receive buffer. The WIFI
    ///  receive buffer has a max size of 1500 byte and if data is transfered
    ///  too fast, it might overflow.
    ///  
    ///  The return values are the number of overflows, the low watermark 
    ///  (i.e. the smallest number of bytes that were free in the buffer) and
    ///  the bytes that are currently used.
    ///  
    ///  You should always try to keep the buffer empty, otherwise you will
    ///  have a permanent latency. A good rule of thumb is, that you can transfer
    ///  1000 messages per second without problems.
    ///  
    ///  Try to not send more then 50 messages at a time without any kind of
    ///  break between them. 
    ///  
    ///  .. versionadded:: 1.3.2
    /// </summary>
    procedure GetWifiBufferInfo(out overflow: longword; out lowWatermark: word; out used: word); virtual;

    /// <summary>
    ///  Sets the regulatory domain of the WIFI Extension. Possible modes are:
    ///  
    ///  <code>
    ///   "Mode", "Description"
    ///  
    ///   "0", "FCC: Channel 1-11 (N/S America, Australia, New Zealand)"
    ///   "1", "ETSI: Channel 1-13 (Europe, Middle East, Africa)"
    ///   "2", "TELEC: Channel 1-14 (Japan)"
    ///  </code>
    ///  
    ///  The default value is 1 (ETSI).
    ///  
    ///  .. versionadded:: 1.3.4
    /// </summary>
    procedure SetWifiRegulatoryDomain(const domain: byte); virtual;

    /// <summary>
    ///  Returns the regulatory domain as set by <see cref="BrickMaster.TBrickMaster.SetWifiRegulatoryDomain"/>.
    ///  
    ///  .. versionadded:: 1.3.4
    /// </summary>
    function GetWifiRegulatoryDomain: byte; virtual;

    /// <summary>
    ///  Calling this function will reset the Brick. Calling this function
    ///  on a Brick inside of a stack will reset the whole stack.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Returns the temperature in °C/10 as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has an
    ///  accuracy of +-15%. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;
  end;

implementation

constructor TBrickMaster.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Master Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 3;
  bindingVersion[2] := 2;
end;

function TBrickMaster.GetStackVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickMaster.GetStackCurrent: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_STACK_CURRENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_STACK_CURRENT, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickMaster.SetExtensionType(const extension: byte; const exttype: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_EXTENSION_TYPE, 9);
  LEConvertUInt8To(extension, 4, request);
  LEConvertUInt32To(exttype, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetExtensionType(const extension: byte): longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE, 5);
  LEConvertUInt8To(extension, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE, response);
  result := LEConvertUInt32From(4, response);
end;

function TBrickMaster.IsChibiPresent: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetChibiAddress(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiAddress: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiMasterAddress(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_MASTER_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiMasterAddress: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiSlaveAddress(const num: byte; const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_SLAVE_ADDRESS, 6);
  LEConvertUInt8To(num, 4, request);
  LEConvertUInt8To(address, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiSlaveAddress(const num: byte): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS, 5);
  LEConvertUInt8To(num, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.GetChibiSignalStrength: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.GetChibiErrorLog(out underrun: word; out crcError: word; out noAck: word; out overflow: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG, response);
  underrun := LEConvertUInt16From(4, response);
  crcError := LEConvertUInt16From(6, response);
  noAck := LEConvertUInt16From(8, response);
  overflow := LEConvertUInt16From(10, response);
end;

procedure TBrickMaster.SetChibiFrequency(const frequency: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_FREQUENCY, 5);
  LEConvertUInt8To(frequency, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiFrequency: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiChannel(const channel: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_CHANNEL, 5);
  LEConvertUInt8To(channel, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiChannel: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.IsRS485Present: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_RS485_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_RS485_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetRS485Address(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetRS485Address: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetRS485SlaveAddress(const num: byte; const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_SLAVE_ADDRESS, 6);
  LEConvertUInt8To(num, 4, request);
  LEConvertUInt8To(address, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetRS485SlaveAddress(const num: byte): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS, 5);
  LEConvertUInt8To(num, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.GetRS485ErrorLog: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickMaster.SetRS485Configuration(const speed: longword; const parity: char; const stopbits: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_CONFIGURATION, 10);
  LEConvertUInt32To(speed, 4, request);
  LEConvertCharTo(parity, 8, request);
  LEConvertUInt8To(stopbits, 9, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetRS485Configuration(out speed: longword; out parity: char; out stopbits: byte);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION, response);
  speed := LEConvertUInt32From(4, response);
  parity := LEConvertCharFrom(8, response);
  stopbits := LEConvertUInt8From(9, response);
end;

function TBrickMaster.IsWifiPresent: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_WIFI_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_WIFI_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetWifiConfiguration(const ssid: string; const connection: byte; const ip: TArray0To3OfUInt8; const subnetMask: TArray0To3OfUInt8; const gateway: TArray0To3OfUInt8; const port: word);
var request: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_CONFIGURATION, 51);
  LEConvertStringTo(ssid, 4, 32, request);
  LEConvertUInt8To(connection, 36, request);
  for i := 0 to Length(ip) - 1 do LEConvertUInt8To(ip[i], 37 + (i * 1), request);
  for i := 0 to Length(subnetMask) - 1 do LEConvertUInt8To(subnetMask[i], 41 + (i * 1), request);
  for i := 0 to Length(gateway) - 1 do LEConvertUInt8To(gateway[i], 45 + (i * 1), request);
  LEConvertUInt16To(port, 49, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetWifiConfiguration(out ssid: string; out connection: byte; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out port: word);
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_CONFIGURATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_CONFIGURATION, response);
  ssid := LEConvertStringFrom(4, 32, response);
  connection := LEConvertUInt8From(36, response);
  for i := 0 to 3 do ip[i] := LEConvertUInt8From(37 + (i * 1), response);
  for i := 0 to 3 do subnetMask[i] := LEConvertUInt8From(41 + (i * 1), response);
  for i := 0 to 3 do gateway[i] := LEConvertUInt8From(45 + (i * 1), response);
  port := LEConvertUInt16From(49, response);
end;

procedure TBrickMaster.SetWifiEncryption(const encryption: byte; const key: string; const keyIndex: byte; const eapOptions: byte; const caCertificateLength: word; const clientCertificateLength: word; const privateKeyLength: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_ENCRYPTION, 63);
  LEConvertUInt8To(encryption, 4, request);
  LEConvertStringTo(key, 5, 50, request);
  LEConvertUInt8To(keyIndex, 55, request);
  LEConvertUInt8To(eapOptions, 56, request);
  LEConvertUInt16To(caCertificateLength, 57, request);
  LEConvertUInt16To(clientCertificateLength, 59, request);
  LEConvertUInt16To(privateKeyLength, 61, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetWifiEncryption(out encryption: byte; out key: string; out keyIndex: byte; out eapOptions: byte; out caCertificateLength: word; out clientCertificateLength: word; out privateKeyLength: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_ENCRYPTION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_ENCRYPTION, response);
  encryption := LEConvertUInt8From(4, response);
  key := LEConvertStringFrom(5, 50, response);
  keyIndex := LEConvertUInt8From(55, response);
  eapOptions := LEConvertUInt8From(56, response);
  caCertificateLength := LEConvertUInt16From(57, response);
  clientCertificateLength := LEConvertUInt16From(59, response);
  privateKeyLength := LEConvertUInt16From(61, response);
end;

procedure TBrickMaster.GetWifiStatus(out macAddress: TArray0To5OfUInt8; out bssid: TArray0To5OfUInt8; out channel: byte; out rssi: smallint; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out rxCount: longword; out txCount: longword; out state: byte);
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_STATUS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_STATUS, response);
  for i := 0 to 5 do macAddress[i] := LEConvertUInt8From(4 + (i * 1), response);
  for i := 0 to 5 do bssid[i] := LEConvertUInt8From(10 + (i * 1), response);
  channel := LEConvertUInt8From(16, response);
  rssi := LEConvertInt16From(17, response);
  for i := 0 to 3 do ip[i] := LEConvertUInt8From(19 + (i * 1), response);
  for i := 0 to 3 do subnetMask[i] := LEConvertUInt8From(23 + (i * 1), response);
  for i := 0 to 3 do gateway[i] := LEConvertUInt8From(27 + (i * 1), response);
  rxCount := LEConvertUInt32From(31, response);
  txCount := LEConvertUInt32From(35, response);
  state := LEConvertUInt8From(39, response);
end;

procedure TBrickMaster.RefreshWifiStatus;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_REFRESH_WIFI_STATUS, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.SetWifiCertificate(const index: word; const data: TArray0To31OfUInt8; const dataLength: byte);
var request: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_CERTIFICATE, 39);
  LEConvertUInt16To(index, 4, request);
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 6 + (i * 1), request);
  LEConvertUInt8To(dataLength, 38, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetWifiCertificate(const index: word; out data: TArray0To31OfUInt8; out dataLength: byte);
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_CERTIFICATE, 6);
  LEConvertUInt16To(index, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_CERTIFICATE, response);
  for i := 0 to 31 do data[i] := LEConvertUInt8From(4 + (i * 1), response);
  dataLength := LEConvertUInt8From(36, response);
end;

procedure TBrickMaster.SetWifiPowerMode(const mode: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_POWER_MODE, 5);
  LEConvertUInt8To(mode, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetWifiPowerMode: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_POWER_MODE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_POWER_MODE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.GetWifiBufferInfo(out overflow: longword; out lowWatermark: word; out used: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_BUFFER_INFO, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_BUFFER_INFO, response);
  overflow := LEConvertUInt32From(4, response);
  lowWatermark := LEConvertUInt16From(8, response);
  used := LEConvertUInt16From(10, response);
end;

procedure TBrickMaster.SetWifiRegulatoryDomain(const domain: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_REGULATORY_DOMAIN, 5);
  LEConvertUInt8To(domain, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetWifiRegulatoryDomain: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_REGULATORY_DOMAIN, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_REGULATORY_DOMAIN, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

end.
