{
  This file was automatically generated on 2012-10-01.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletHumidity;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY = 1;
  BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE = 2;
  BRICKLET_HUMIDITY_FUNCTION_SET_HUMIDITY_CALLBACK_PERIOD = 3;
  BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY_CALLBACK_PERIOD = 4;
  BRICKLET_HUMIDITY_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;
  BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;
  BRICKLET_HUMIDITY_FUNCTION_SET_HUMIDITY_CALLBACK_THRESHOLD = 7;
  BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY_CALLBACK_THRESHOLD = 8;
  BRICKLET_HUMIDITY_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;
  BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;
  BRICKLET_HUMIDITY_FUNCTION_SET_DEBOUNCE_PERIOD = 11;
  BRICKLET_HUMIDITY_FUNCTION_GET_DEBOUNCE_PERIOD = 12;
  BRICKLET_HUMIDITY_CALLBACK_HUMIDITY = 13;
  BRICKLET_HUMIDITY_CALLBACK_ANALOG_VALUE = 14;
  BRICKLET_HUMIDITY_CALLBACK_HUMIDITY_REACHED = 15;
  BRICKLET_HUMIDITY_CALLBACK_ANALOG_VALUE_REACHED = 16;

type
  TBrickletHumidityNotifyHumidity = procedure(const humidity: word) of object;
  TBrickletHumidityNotifyAnalogValue = procedure(const value: word) of object;
  TBrickletHumidityNotifyHumidityReached = procedure(const humidity: word) of object;
  TBrickletHumidityNotifyAnalogValueReached = procedure(const value: word) of object;

  /// <summary>
  ///  Device for sensing Humidity
  /// </summary>
  TBrickletHumidity = class(TDevice)
  private
    humidityCallback: TBrickletHumidityNotifyHumidity;
    analogValueCallback: TBrickletHumidityNotifyAnalogValue;
    humidityReachedCallback: TBrickletHumidityNotifyHumidityReached;
    analogValueReachedCallback: TBrickletHumidityNotifyAnalogValueReached;
  protected
    procedure CallbackWrapperHumidity(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValue(const packet: TByteArray); virtual;
    procedure CallbackWrapperHumidityReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid_: string);

    /// <summary>
    ///  Returns the humidity of the sensor. The value
    ///  has a range of 0 to 1000 and is given in %RH/10 (Relative Humidity), 
    ///  i.e. a value of 421 means that a humidity of 42.1 %RH is measured.
    ///  
    ///  If you want to get the humidity periodically, it is recommended to use the
    ///  callback <see cref="BrickletHumidity.TBrickletHumidity.Humidity"/> and set the period with 
    ///  <see cref="BrickletHumidity.TBrickletHumidity.SetHumidityCallbackPeriod"/>.
    /// </summary>
    function GetHumidity: word; virtual;

    /// <summary>
    ///  Returns the value as read by a 12-bit analog-to-digital converter.
    ///  The value is between 0 and 4095.
    ///  
    ///  <note>
    ///   The value returned by <see cref="BrickletHumidity.TBrickletHumidity.GetHumidity"/> is averaged over several samples
    ///   to yield less noise, while <see cref="BrickletHumidity.TBrickletHumidity.GetAnalogValue"/> gives back raw
    ///   unfiltered analog values. The returned humidity value is calibrated for
    ///   room temperatures, if you use the sensor in extreme cold or extreme
    ///   warm environments, you might want to calculate the humidity from
    ///   the analog value yourself. See the `HIH 5030 datasheet
    ///   &lt;https://github.com/Tinkerforge/humidity-bricklet/raw/master/datasheets/hih-5030.pdf&gt;`__.
    ///  </note>
    ///  
    ///  If you want the analog value periodically, it is recommended to use the 
    ///  callback <see cref="BrickletHumidity.TBrickletHumidity.AnalogValue"/> and set the period with 
    ///  <see cref="BrickletHumidity.TBrickletHumidity.SetAnalogValueCallbackPeriod"/>.
    /// </summary>
    function GetAnalogValue: word; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickletHumidity.TBrickletHumidity.Humidity"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  <see cref="BrickletHumidity.TBrickletHumidity.Humidity"/> is only triggered if the humidity has changed since the
    ///  last triggering.
    ///  
    ///  The default value is 0.
    /// </summary>
    procedure SetHumidityCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletHumidity.TBrickletHumidity.SetHumidityCallbackPeriod"/>.
    /// </summary>
    function GetHumidityCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period in ms with which the <see cref="BrickletHumidity.TBrickletHumidity.AnalogValue"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  <see cref="BrickletHumidity.TBrickletHumidity.AnalogValue"/> is only triggered if the analog value has changed since the
    ///  last triggering.
    ///  
    ///  The default value is 0.
    /// </summary>
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletHumidity.TBrickletHumidity.SetAnalogValueCallbackPeriod"/>.
    /// </summary>
    function GetAnalogValueCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletHumidity.TBrickletHumidity.HumidityReached"/> callback. 
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the humidity is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the humidity is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the humidity is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the humidity is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  The default value is ('x', 0, 0).
    /// </summary>
    procedure SetHumidityCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletHumidity.TBrickletHumidity.SetHumidityCallbackThreshold"/>.
    /// </summary>
    procedure GetHumidityCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletHumidity.TBrickletHumidity.AnalogValueReached"/> callback. 
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  The default value is ('x', 0, 0).
    /// </summary>
    procedure SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletHumidity.TBrickletHumidity.SetAnalogValueCallbackThreshold"/>.
    /// </summary>
    procedure GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word); virtual;

    /// <summary>
    ///  Sets the period in ms with which the threshold callbacks
    ///  
    ///   <see cref="BrickletHumidity.TBrickletHumidity.HumidityReached"/>, <see cref="BrickletHumidity.TBrickletHumidity.AnalogValueReached"/>
    ///  
    ///  are triggered, if the thresholds
    ///  
    ///   <see cref="BrickletHumidity.TBrickletHumidity.SetHumidityCallbackThreshold"/>, <see cref="BrickletHumidity.TBrickletHumidity.SetAnalogValueCallbackThreshold"/>
    ///  
    ///  keep being reached.
    ///  
    ///  The default value is 100.
    /// </summary>
    procedure SetDebouncePeriod(const debounce: longword); virtual;

    /// <summary>
    ///  Returns the debounce period as set by <see cref="BrickletHumidity.TBrickletHumidity.SetDebouncePeriod"/>.
    /// </summary>
    function GetDebouncePeriod: longword; virtual;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletHumidity.TBrickletHumidity.SetHumidityCallbackPeriod"/>. The parameter is the humidity of the
    ///  sensor.
    ///  
    ///  <see cref="BrickletHumidity.TBrickletHumidity.Humidity"/> is only triggered if the humidity has changed since the
    ///  last triggering.
    /// </summary>
    property OnHumidity: TBrickletHumidityNotifyHumidity read humidityCallback write humidityCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletHumidity.TBrickletHumidity.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value of the
    ///  sensor.
    ///  
    ///  <see cref="BrickletHumidity.TBrickletHumidity.AnalogValue"/> is only triggered if the humidity has changed since the
    ///  last triggering.
    /// </summary>
    property OnAnalogValue: TBrickletHumidityNotifyAnalogValue read analogValueCallback write analogValueCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletHumidity.TBrickletHumidity.SetHumidityCallbackThreshold"/> is reached.
    ///  The parameter is the humidity of the sensor.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletHumidity.TBrickletHumidity.SetDebouncePeriod"/>.
    /// </summary>
    property OnHumidityReached: TBrickletHumidityNotifyHumidityReached read humidityReachedCallback write humidityReachedCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletHumidity.TBrickletHumidity.SetAnalogValueCallbackThreshold"/> is reached.
    ///  The parameter is the analog value of the sensor.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletHumidity.TBrickletHumidity.SetDebouncePeriod"/>.
    /// </summary>
    property OnAnalogValueReached: TBrickletHumidityNotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
  end;

implementation

constructor TBrickletHumidity.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Humidity Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_HUMIDITY_CALLBACK_HUMIDITY] := {$ifdef FPC}@{$endif}CallbackWrapperHumidity;
  callbackWrappers[BRICKLET_HUMIDITY_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_HUMIDITY_CALLBACK_HUMIDITY_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperHumidityReached;
  callbackWrappers[BRICKLET_HUMIDITY_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
end;

function TBrickletHumidity.GetHumidity: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickletHumidity.GetAnalogValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletHumidity.SetHumidityCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_SET_HUMIDITY_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletHumidity.GetHumidityCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletHumidity.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletHumidity.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletHumidity.SetHumidityCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_SET_HUMIDITY_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletHumidity.GetHumidityCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_HUMIDITY_FUNCTION_GET_HUMIDITY_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletHumidity.SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletHumidity.GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_HUMIDITY_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertUInt16From(5, response);
  max := LEConvertUInt16From(7, response);
end;

procedure TBrickletHumidity.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletHumidity.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_HUMIDITY_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_HUMIDITY_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletHumidity.CallbackWrapperHumidity(const packet: TByteArray);
var humidity: word;
begin
  if (Assigned(humidityCallback)) then begin
    humidity := LEConvertUInt16From(4, packet);
    humidityCallback(humidity);
  end;
end;

procedure TBrickletHumidity.CallbackWrapperAnalogValue(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueCallback(value);
  end;
end;

procedure TBrickletHumidity.CallbackWrapperHumidityReached(const packet: TByteArray);
var humidity: word;
begin
  if (Assigned(humidityReachedCallback)) then begin
    humidity := LEConvertUInt16From(4, packet);
    humidityReachedCallback(humidity);
  end;
end;

procedure TBrickletHumidity.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueReachedCallback(value);
  end;
end;

end.
